<template>
  <v-app>
    <v-content>
      <v-container class="fill-height" fluid>
        <v-row align="center" justify="center">
          <v-col cols="12" sm="8" md="4">
              <v-toolbar>
                <v-toolbar-title>Login form</v-toolbar-title>
              </v-toolbar>
              <v-card-text>
                <vue-tel-input v-model="phone" v-bind="bindProps"></vue-tel-input>
                <v-btn @click="sendCode">send code</v-btn>
                <v-card id="recaptcha-container"></v-card>
                <v-text-field v-model="vcode"></v-text-field>
                <v-list-tile-sub-title>*Personal or Company phone number</v-list-tile-sub-title>
              </v-card-text>
              <v-card-actions>
                <v-btn color="primary" block="true" outlined="true" @click="login">Login or Register</v-btn>
              </v-card-actions>
          </v-col>
        </v-row>
      </v-container>
    </v-content>
  </v-app>
</template>

<script>
import { VueTelInput } from 'vue-tel-input'
export default {
  data () {
    return {
      phone: '',
      vcode: '',
      bindProps: {
        mode: 'international',
        inputOptions: {
          disabledDialCode: 'false'
        }
      },
      appVerifier: '',
      country: ''
    }
  },
  components: {
    VueTelInput
  },
  watch: {
    phone: (data) => {
      console.log('phone data', data)
    }
  },
  methods: {
    sendCode () {
      const phoneNumber = this.phone.replace(' ', '')
      //
      const appVerifier = window.recaptchaVerifier
      //
      this.$firebase.auth().signInWithPhoneNumber(phoneNumber, appVerifier)
        .then(function (confirmationResult) {
          // SMS sent. Prompt user to type the code from the message, then sign the
          // user in with confirmationResult.confirm(code).
          window.confirmationResult = confirmationResult
          console.log('sendcodeuser', this.$firebase.auth().currentUser)
          //
          alert('SMS sent')
        }).catch(error => {
          console.log('sign in error', error)
        })
    },
    login () {
      const code = this.vcode
      //
      window.confirmationResult.confirm(code)
        .then(result => {
          console.log('result', result, this.$router)
          this.$store.dispatch('account/createAccount')
            .then(() => {
              this.$router.push({ path: '/' })
              console.log('loginuser', this.$firebase.auth().currentUser)
            }).catch(error => {
              this.$router.push({ path: '/login' })
              console.log('sign in error', error, this.$router)
            })
        }).catch(error => {
          this.$router.push({ path: '/login' })
          console.log('sign in error', error, this.$router)
        })
    }
  },
  mounted () {
    window.recaptchaVerifier = new this.$firebase.auth.RecaptchaVerifier('recaptcha-container', {
      size: 'invisible',
      callback: function (response) {
        // reCAPTCHA solved, allow signInWithPhoneNumber.
        console.log('ReCaptcha response', response)
      },
      'expired-callback': function () {
        // Response expired. Ask user to solve reCAPTCHA again.
        // ...
      }
    })
  }
}
</script>
